package org.kie.kogito.examples;

import org.kie.kogito.Config;
import org.kie.kogito.process.Processes;

@javax.inject.Singleton()
public class Application implements org.kie.kogito.Application {

    public Config config() {
        return config;
    }

    public static org.kie.kogito.Config config = new org.kie.kogito.StaticConfig(new org.kie.kogito.process.impl.StaticProcessConfig(new org.kie.kogito.process.impl.DefaultWorkItemHandlerConfig(), new org.kie.kogito.process.impl.DefaultProcessEventListenerConfig()), null);

    public Processes processes() {
        return new Processes();
    }

    public class Processes implements org.kie.kogito.process.Processes {

        public org.kie.kogito.process.Process<? extends org.kie.kogito.Model> processById(String processId) {
            if ("demo.orderItems".equals(processId))
                return createOrderItemsProcess();
            if ("demo.orders".equals(processId))
                return createOrdersProcess();
            return null;
        }

        public java.util.Collection<String> processIds() {
            return java.util.Arrays.asList("demo.orderItems", "demo.orders");
        }

        public org.kie.kogito.examples.OrderItemsProcess createOrderItemsProcess() {
            return new org.kie.kogito.examples.OrderItemsProcess(Application.this).configure();
        }

        public org.kie.kogito.examples.OrdersProcess createOrdersProcess() {
            return new org.kie.kogito.examples.OrdersProcess(Application.this).configure();
        }
    }
}
